					EXPORT	LINEDDA_BOX_ROTATION_DEMO_VRAMADDR
					EXPORT	LINEDDA_BOX_ROTATION_DEMO_CX
					EXPORT	LINEDDA_BOX_ROTATION_DEMO_CY
					EXPORT	LINEDDA_BOX_ROTATION_DEMO
					EXPORT	LINEDDA_BOX_ROTATION_DEMO_MAIN

					EXPORT	LINEDDA_BOX_ROTATION_DEMO_INIT
					EXPORT	LINEDDA_BOX_ROTATION_DEMO_CLEANUP
					EXPORT	LINEDDA_BOX_ROTATION_DEMO_ONESTEP
					EXPORT	LINEDDA_BOX_ROTATION_DEMO_OVER

LINEDDA_BOX_ROTATION_DEMO_VRAMADDR	FDB 0
LINEDDA_BOX_ROTATION_DEMO_CX		FDB 320
LINEDDA_BOX_ROTATION_DEMO_CY		FDB 100
LINEDDA_BOX_ROTATION_DEMO_ANGLE0	FCB	0
LINEDDA_BOX_ROTATION_DEMO_BUFFADDR	FDB	LINEDDA_IN_SUBCPU_BUFFER

LINEDDA_BOX_ROTATION_DEMO_OVER		FCB	0
LINEDDA_BOX_ROTATION_DEMO_OUTSIDECOUNT	FCB	0


LINEDDA_BOX_ROTATION_DEMO
					BSR		LINEDDA_BOX_ROTATION_DEMO_INIT
LINEDDA_BOX_ROTATION_DEMO_OUTSIDELOOP
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_BOX_ROTATION_DEMO_OUTSIDELOOP_END

					BSR		LINEDDA_BOX_ROTATION_DEMO_ONESTEP
					TST		LINEDDA_BOX_ROTATION_DEMO_OVER,PCR
					BEQ		LINEDDA_BOX_ROTATION_DEMO_OUTSIDELOOP
					BSR		LINEDDA_BOX_ROTATION_DEMO_CLEANUP
LINEDDA_BOX_ROTATION_DEMO_OUTSIDELOOP_END
					RTS



LINEDDA_BOX_ROTATION_DEMO_INIT
					PSHS	A,B
					LBSR	INSTALL_LINEDDA_IN_SUBCPU
					LBSR	INSTALL_CLEAR_BITPLANE_IN_SUBCPU
					CLR		LINEDDA_BOX_ROTATION_DEMO_OVER,PCR
					CLR		LINEDDA_BOX_ROTATION_DEMO_OUTSIDECOUNT,PCR
					LDD		#COMMON_LINEBUFPTR
					STD		LINEDDA_BOX_ROTATION_DEMO_BUFFADDR,PCR
					PULS	A,B,PC



LINEDDA_BOX_ROTATION_DEMO_CLEANUP
					RTS



LINEDDA_BOX_ROTATION_DEMO_ONESTEP
					PSHS	A,B,X,Y,U

					LBSR	GET_RANDOM
					LDA		RANDOM_NUMBER,PCR
					STA		LINEDDA_BOX_ROTATION_DEMO_ANGLE0,PCR

					LDX		#639
					STX		RANDOM_NUMBER_RANGE
					LBSR	GET_RANDOM_IN_RANGE
					LDX		RANDOM_NUMBER,PCR
					STX		LINEDDA_BOX_ROTATION_DEMO_CX,PCR

					LDX		#199
					STX		RANDOM_NUMBER_RANGE
					LBSR	GET_RANDOM_IN_RANGE
					LDX		RANDOM_NUMBER,PCR
					STX		LINEDDA_BOX_ROTATION_DEMO_CY,PCR

					BSR		LINEDDA_BOX_ROTATION_DEMO_MAIN

					LDX		LINEDDA_BOX_ROTATION_DEMO_VRAMADDR,PCR
					LEAX	$4000,X
					CMPX	#$8000
					BCS		LINEDDA_BOX_ROTATION_DEMO_SETNEXTVRAMADDR
					BEQ		LINEDDA_BOX_ROTATION_DEMO_SETNEXTVRAMADDR
					LDX		#0
LINEDDA_BOX_ROTATION_DEMO_SETNEXTVRAMADDR
					STX		LINEDDA_BOX_ROTATION_DEMO_VRAMADDR,PCR

					INC		LINEDDA_BOX_ROTATION_DEMO_OUTSIDECOUNT,PCR
					LDA		LINEDDA_BOX_ROTATION_DEMO_OUTSIDECOUNT,PCR
					CMPA	#8
					BLO		LINEDDA_BOX_ROTATION_DEMO_ONESTEP_END
					STA		LINEDDA_BOX_ROTATION_DEMO_OVER,PCR
LINEDDA_BOX_ROTATION_DEMO_ONESTEP_END
					PULS	A,B,X,Y,U,PC



LINEDDA_BOX_ROTATION_DEMO_MAIN
					PSHS	A,B,X,Y,U

					LDA		#60		; 60 times 4 lines=240 lines.
					STA		LINEDDA_BOX_ROTATION_DEMO_COUNT,PCR
					LDA		LINEDDA_BOX_ROTATION_DEMO_ANGLE0,PCR
					STA		LINEDDA_BOX_ROTATION_DEMO_ANGLE,PCR

					LDX		#20
					STX		LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR

					LDU		LINEDDA_BOX_ROTATION_DEMO_BUFFADDR,PCR
					LDX		LINEDDA_BOX_ROTATION_DEMO_VRAMADDR,PCR
					STX		,U++

					LDA		#80
					STA		,U+		; 80 bytes per line

					LDA		#1
					STA		,U+		; Needs to be one.

					LEAY	0,U
					CLR		,U+		; Number of lines


LINEDDA_BOX_ROTATION_DEMO_LOOP
					LDA		LINEDDA_BOX_ROTATION_DEMO_ANGLE,PCR
					STA		ROTATE2D_A,PCR

					LDD		LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR
					STD		ROTATE2D_X,PCR
					STD		ROTATE2D_Y,PCR
					LBSR	ROTATE2D
					LDD		ROTATE2D_X,PCR
					STD		LINEDDA_BOX_ROTATION_DEMO_X0,PCR
					STD		LINEDDA_BOX_ROTATION_DEMO_X4,PCR
					LDD		ROTATE2D_Y,PCR
					ASRA
					RORB
					STD		LINEDDA_BOX_ROTATION_DEMO_Y0,PCR
					STD		LINEDDA_BOX_ROTATION_DEMO_Y4,PCR

					CLRA
					CLRB
					SUBD	LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR
					STD		ROTATE2D_X,PCR
					LDD		LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR
					STD		ROTATE2D_Y,PCR
					LBSR	ROTATE2D
					LDD		ROTATE2D_X,PCR
					STD		LINEDDA_BOX_ROTATION_DEMO_X1,PCR
					LDD		ROTATE2D_Y,PCR
					ASRA
					RORB
					STD		LINEDDA_BOX_ROTATION_DEMO_Y1,PCR

					CLRA
					CLRB
					SUBD	LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR
					STD		ROTATE2D_X,PCR
					STD		ROTATE2D_Y,PCR
					LBSR	ROTATE2D
					LDD		ROTATE2D_X,PCR
					STD		LINEDDA_BOX_ROTATION_DEMO_X2,PCR
					LDD		ROTATE2D_Y,PCR
					ASRA
					RORB
					STD		LINEDDA_BOX_ROTATION_DEMO_Y2,PCR

					LDD		LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR
					STD		ROTATE2D_X,PCR
					CLRA
					CLRB
					SUBD	LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR
					STD		ROTATE2D_Y,PCR
					LBSR	ROTATE2D
					LDD		ROTATE2D_X,PCR
					STD		LINEDDA_BOX_ROTATION_DEMO_X3,PCR
					LDD		ROTATE2D_Y,PCR
					ASRA
					RORB
					STD		LINEDDA_BOX_ROTATION_DEMO_Y3,PCR

					LDX		#0
					STX		SCLIP_WX0,PCR
					LDX		#0
					STX		SCLIP_WY0,PCR
					LDX		#639
					STX		SCLIP_WX1,PCR
					LDX		#199
					STX		SCLIP_WY1,PCR

					LDA		#4
					LEAX	LINEDDA_BOX_ROTATION_DEMO_X0,PCR
LINEDDA_BOX_ROTATION_DEMO_INSIDE_LOOP
					PSHS	A
					LDD		,X++
					ADDD	LINEDDA_BOX_ROTATION_DEMO_CX,PCR
					STD		SCLIP_LX0,PCR
					LDD		,X++
					ADDD	LINEDDA_BOX_ROTATION_DEMO_CY,PCR
					STD		SCLIP_LY0,PCR
					LDD		,X
					ADDD	LINEDDA_BOX_ROTATION_DEMO_CX,PCR
					STD		SCLIP_LX1,PCR
					LDD		2,X
					ADDD	LINEDDA_BOX_ROTATION_DEMO_CY,PCR
					STD		SCLIP_LY1,PCR
					LBSR	SCRNCLIP
					LDA		SCLIP_VISIBLE,PCR
					BEQ		LINEDDA_BOX_ROTATION_DEMO_INSIDE_LOOP_NEXT

					LDD		SCLIP_LX0,PCR
					STD		,U++
					LDD		SCLIP_LY0,PCR
					STB		,U+
					LDD		SCLIP_LX1,PCR
					STD		,U++
					LDD		SCLIP_LY1,PCR
					STB		,U+
					INC		,Y

LINEDDA_BOX_ROTATION_DEMO_INSIDE_LOOP_NEXT
					PULS	A
					DECA
					BNE		LINEDDA_BOX_ROTATION_DEMO_INSIDE_LOOP

					; Outside loop
					LDD		LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR
					ADDD	#10
					STD		LINEDDA_BOX_ROTATION_DEMO_BOXSIZE,PCR
					LDA		LINEDDA_BOX_ROTATION_DEMO_ANGLE,PCR
					ADDA	#8
					STA		LINEDDA_BOX_ROTATION_DEMO_ANGLE,PCR

					DEC		LINEDDA_BOX_ROTATION_DEMO_COUNT,PCR
					LBNE	LINEDDA_BOX_ROTATION_DEMO_LOOP


					LDU		LINEDDA_BOX_ROTATION_DEMO_BUFFADDR,PCR
					STU		CALL_LINEDDA_SUBCPU_DATAADDR,PCR
					LBSR	CALL_LINEDDA_SUBCPU

					PULS	A,B,X,Y,U
					RTS

LINEDDA_BOX_ROTATION_DEMO_COUNT		FCB 0
LINEDDA_BOX_ROTATION_DEMO_ANGLE		FCB	0
LINEDDA_BOX_ROTATION_DEMO_BOXSIZE	FDB	0
LINEDDA_BOX_ROTATION_DEMO_X0		FDB 0
LINEDDA_BOX_ROTATION_DEMO_Y0		FDB 0
LINEDDA_BOX_ROTATION_DEMO_X1		FDB 0
LINEDDA_BOX_ROTATION_DEMO_Y1		FDB 0
LINEDDA_BOX_ROTATION_DEMO_X2		FDB 0
LINEDDA_BOX_ROTATION_DEMO_Y2		FDB 0
LINEDDA_BOX_ROTATION_DEMO_X3		FDB 0
LINEDDA_BOX_ROTATION_DEMO_Y3		FDB 0
LINEDDA_BOX_ROTATION_DEMO_X4		FDB 0
LINEDDA_BOX_ROTATION_DEMO_Y4		FDB 0
