					EXPORT	LINEDDA_CIRCLE_DEMO
					EXPORT	LINEDDA_CIRCLE_DEMO_INIT
					EXPORT	LINEDDA_CIRCLE_DEMO_ONESTEP
					EXPORT	LINEDDA_CIRCLE_DEMO_CLEANUP
					EXPORT	LINEDDA_CIRCLE_DEMO_OVER


LINEDDA_CIRCLE_DEMO_OVER	FCB	0
LINEDDA_CIRCLE_DEMO_COUNT	FCB	0
LINEDDA_CIRCLE_VRAM			FDB	0


LINEDDA_CIRCLE_DEMO
					BSR		LINEDDA_CIRCLE_DEMO_INIT
LINEDDA_CIRCLE_DEMO_LOOP
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_CIRCLE_DEMO_LOOP_END

					BSR		LINEDDA_CIRCLE_DEMO_ONESTEP
					TST		LINEDDA_CIRCLE_DEMO_OVER,PCR
					BEQ		LINEDDA_CIRCLE_DEMO_LOOP
					BSR		LINEDDA_CIRCLE_DEMO_CLEANUP

LINEDDA_CIRCLE_DEMO_LOOP_END
					RTS


LINEDDA_CIRCLE_DEMO_CLEANUP
					RTS


LINEDDA_CIRCLE_DEMO_INIT
					PSHS	A,B
					LBSR	INSTALL_LINEDDA_IN_SUBCPU
					LBSR	INSTALL_CLEAR_BITPLANE_IN_SUBCPU
					CLR		LINEDDA_CIRCLE_DEMO_OVER,PCR
					CLR		LINEDDA_CIRCLE_DEMO_COUNT,PCR
					CLRA
					CLRB
					STD		LINEDDA_CIRCLE_VRAM,PCR
					PULS	A,B,PC

LINEDDA_CIRCLE_DEMO_ONESTEP
					PSHS	A,B,X,Y,U
					LDU		#COMMON_LINEBUFPTR
					STU		DRAW_CIRCLE_BUFFADDR,PCR

					LDX		#639
					STX		RANDOM_NUMBER_RANGE
					LBSR	GET_RANDOM_IN_RANGE
					LDX		RANDOM_NUMBER,PCR
					STX		DRAW_CIRCLE_SUBCPU_CX,PCR

					LDX		#199
					STX		RANDOM_NUMBER_RANGE
					LBSR	GET_RANDOM_IN_RANGE
					LDX		RANDOM_NUMBER,PCR
					STX		DRAW_CIRCLE_SUBCPU_CY,PCR

					LDX		#8
					LDU		#0

LINEDDA_CIRCLE_DEMO_INSIDELOOP
					STU		DRAW_CIRCLE_VRAMADDR,PCR
					STX		DRAW_CIRCLE_SUBCPU_R,PCR

					LBSR	DRAW_CIRCLE_SUBCPU

					LEAU	$4000,U
					CMPU	#$8000
					BCS		LINEDDA_CIRCLE_DEMO_INSIDELOOP_NEXT
					BEQ		LINEDDA_CIRCLE_DEMO_INSIDELOOP_NEXT
					LDU		#0

LINEDDA_CIRCLE_DEMO_INSIDELOOP_NEXT
					LEAX	24,X
					CMPX	#500
					BLE		LINEDDA_CIRCLE_DEMO_INSIDELOOP

					INC		LINEDDA_CIRCLE_DEMO_COUNT,PCR
					LDA		LINEDDA_CIRCLE_DEMO_COUNT,PCR
					CMPA	#8
					BLO		LINEDDA_CIRCLE_DEMO_END
					STA		LINEDDA_CIRCLE_DEMO_OVER,PCR
LINEDDA_CIRCLE_DEMO_END
					PULS	A,B,X,Y,U,PC



