					EXPORT	TEST_LINEDDA_SUBCPU_EXHAUSTIVE
					EXPORT	TEST_LINEDDA_SUBCPU_EXHAUSTIVE_BUFFERADDR

					EXPORT	LINEDDA_LINE_ROTATION_DEMO_OVER
					EXPORT	LINEDDA_LINE_ROTATION_DEMO
					EXPORT	LINEDDA_LINE_ROTATION_DEMO_INIT
					EXPORT	LINEDDA_LINE_ROTATION_DEMO_ONESTEP
					EXPORT	LINEDDA_LINE_ROTATION_DEMO_CLEANUP



LINEDDA_DEMO_MAIN	PSHS	A,B,X,Y,U,CC
					ORCC	#$40

					LEAX	MOONLIGHT_SONATA,PCR
					STX		PSGPLAY_DATAPTR,PCR

					LBSR	PSGPLAY_SET_IRQ_HOOK
					LBSR	PSGPLAY_START

					LBSR	INSTALL_LINEDDA_IN_SUBCPU
					LBSR	INSTALL_CLEAR_BITPLANE_IN_SUBCPU



					LBSR	CLEAR_SCREEN
					LDA		#8
					LBSR	LINEDDA_BOX_ROTATION_DEMO
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_DEMO_END



					LBSR	CLEAR_SCREEN
					LBSR	LINEDDA_STAR_DEMO
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_DEMO_END



					LBSR	CLEAR_SCREEN
					LBSR	CUBE_DEMO
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_DEMO_END



					LBSR	CLEAR_SCREEN
					LBSR	LINEDDA_CIRCLE_DEMO
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_DEMO_END



					LBSR	CLEAR_SCREEN
					LBSR	FLIGHTDEMO
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_DEMO_END



					LBSR	CLEAR_SCREEN
					LBSR	LINEDDA_LINE_ROTATION_DEMO
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_DEMO_END



LINEDDA_DEMO_END
					LDX		#$FD38
					LDA		#0
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+

					LBSR	CLEAR_SCREEN
					PULS	A,B,X,Y,U,CC,PC



					; What's the hell!  It's just 640x200.
					; Just test exhaustively by drawing 1.5M lines.
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_XSTEP			EQU	7
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_YSTEP			EQU	7
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_BUFFERADDR	FDB	COMMON_LINEBUFPTR
TEST_LINEDDA_SUBCPU_EXHAUSTIVE
					PSHS	A,B,X,Y,U

					LBSR	INSTALL_LINEDDA_IN_SUBCPU
					LBSR	INSTALL_CLEAR_BITPLANE_IN_SUBCPU

					LDX		#0
					STX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X0,PCR
					STX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y0,PCR
					STX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X1,PCR
					STX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y1,PCR

TEST_LINEDDA_SUBCPU_EXHAUSTIVE_OUTSIDELOOP_X
					LDX		#0
					STX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y0,PCR

TEST_LINEDDA_SUBCPU_EXHAUSTIVE_OUTSIDELOOP_Y

					LBSR	CLEAR_SCREEN

					LDX		#0
					STX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X1,PCR
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_INSIDELOOP_X

					LDX		#0
					STX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y1,PCR



					LDU		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_BUFFERADDR,PCR

					LDX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_VRAMADDR,PCR
					STX		,U++

					LDA		#80	; Number of bytes per line
					STA		,U+

					LDA		#1  ; Needs to be one at this time.
					STA		,U+

					TFR		U,Y
					CLR		,U+
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_INSIDELOOP_Y
					LDX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X0,PCR
					STX		,U++
					LDD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y0,PCR
					STB		,U+
					LDX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X1,PCR
					STX		,U++
					LDD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y1,PCR
					STB		,U+
					INC		,Y


					LDD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y1,PCR
					ADDD	#TEST_LINEDDA_SUBCPU_EXHAUSTIVE_YSTEP
					STD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y1,PCR
					CMPD	#200
					BLO		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_INSIDELOOP_Y

					LDX		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_BUFFERADDR,PCR
					TFR		U,D
					SUBD	TEST_LINEDDA_SUBCPU_EXHAUSTIVE_BUFFERADDR,PCR
					LBSR	LINEDDA_STAR_DEMO_RUN


					LDD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_VRAMADDR,PCR
					ADDD	#$4000
					CMPD	#$C000
					BNE		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_SETVRAMADDR
					LDD		#0
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_SETVRAMADDR
					STD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_VRAMADDR,PCR


					LDD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X1,PCR
					ADDD	#TEST_LINEDDA_SUBCPU_EXHAUSTIVE_XSTEP
					STD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X1,PCR
					CMPD	#640
					BLO		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_INSIDELOOP_X

					LDD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y0,PCR
					ADDD	#TEST_LINEDDA_SUBCPU_EXHAUSTIVE_YSTEP
					STD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y0,PCR
					CMPD	#200
					LBLO	TEST_LINEDDA_SUBCPU_EXHAUSTIVE_OUTSIDELOOP_Y

					LDD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X0,PCR
					ADDD	#TEST_LINEDDA_SUBCPU_EXHAUSTIVE_XSTEP
					STD		TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X0,PCR
					CMPD	#640
					LBLO	TEST_LINEDDA_SUBCPU_EXHAUSTIVE_OUTSIDELOOP_X



					PULS	A,B,X,Y,U
					RTS

TEST_LINEDDA_SUBCPU_EXHAUSTIVE_VRAMADDR	FDB	0
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X0	RZB	2
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y0	RZB	2
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_X1	RZB	2
TEST_LINEDDA_SUBCPU_EXHAUSTIVE_Y1	RZB	2


LINEDDA_LINE_ROTATION_DEMO_OVER		FCB	0

LINEDDA_LINE_ROTATION_DEMO
					BSR		LINEDDA_LINE_ROTATION_DEMO_INIT
LINEDDA_LINE_ROTATION_DEMO_LOOP
					LDA		$FD04
					BITA	#2
					BEQ		LINEDDA_LINE_ROTATION_DEMO_LOOP_END

					LBSR		LINEDDA_LINE_ROTATION_DEMO_ONESTEP
					TST		LINEDDA_LINE_ROTATION_DEMO_OVER,PCR
					BEQ		LINEDDA_LINE_ROTATION_DEMO_LOOP
					LBSR		LINEDDA_LINE_ROTATION_DEMO_CLEANUP
LINEDDA_LINE_ROTATION_DEMO_LOOP_END
					RTS


LINEDDA_LINE_ROTATION_DEMO_INIT
					PSHS	A,B,X,Y,U
					CLR		LINEDDA_LINE_ROTATION_DEMO_OVER,PCR

					LDX		#0
					LDY		#0
					STX		LINEDDA_LINE_ROTATION_DEMO_X0,PCR
					STY		LINEDDA_LINE_ROTATION_DEMO_Y0,PCR
					LDX		#639
					LDY		#0
					STX		LINEDDA_LINE_ROTATION_DEMO_X1,PCR
					STY		LINEDDA_LINE_ROTATION_DEMO_Y1,PCR

					LDU		#COMMON_LINEBUFPTR
					LDX		#0
					STX		,U++

					LDA		#80
					STA		,U+		; 80 bytes per line

					LDA		#1
					STA		,U+		; Needs to be one.

					LEAY	0,U
					CLR		,U+		; Number of lines

					LDA		#104
LINEDDA_LINE_ROTATION_DEMO_MAKE_BUFFER_LOOP
					PSHS	A

					LEAX	LINEDDA_LINE_ROTATION_DEMO_X0,PCR
					LDD		,X++
					STD		,U++
					LDD		,X++
					STB		,U+
					LDD		,X++
					STD		,U++
					LDD		,X++
					STB		,U+
					INC		,Y

					PSHS	Y
					LDX		LINEDDA_LINE_ROTATION_DEMO_X0,PCR
					LDY		LINEDDA_LINE_ROTATION_DEMO_Y0,PCR
					BSR		LINEDDA_LINE_ROTATION_DEMO_MOVE
					STX		LINEDDA_LINE_ROTATION_DEMO_X0,PCR
					STY		LINEDDA_LINE_ROTATION_DEMO_Y0,PCR

					LDX		LINEDDA_LINE_ROTATION_DEMO_X1,PCR
					LDY		LINEDDA_LINE_ROTATION_DEMO_Y1,PCR
					BSR		LINEDDA_LINE_ROTATION_DEMO_MOVE
					STX		LINEDDA_LINE_ROTATION_DEMO_X1,PCR
					STY		LINEDDA_LINE_ROTATION_DEMO_Y1,PCR
					PULS	Y

					PULS	A
					DECA
					BNE		LINEDDA_LINE_ROTATION_DEMO_MAKE_BUFFER_LOOP

					LDX		#0
					STX		LINEDDA_LINE_ROTATION_DEMO_VRAMADDR,PCR

					PULS	A,B,X,Y,U,PC



LINEDDA_LINE_ROTATION_DEMO_ONESTEP
					PSHS	A,B,X,Y,U

					LDU		#COMMON_LINEBUFPTR
					STU		CALL_LINEDDA_SUBCPU_DATAADDR,PCR
LINEDDA_LINE_ROTATION_DEMO_RENDER_LOOP
					LDX		LINEDDA_LINE_ROTATION_DEMO_VRAMADDR,PCR
					STX		,U

					LBSR	CALL_LINEDDA_SUBCPU

					LEAX	$4000,X
					STX		LINEDDA_LINE_ROTATION_DEMO_VRAMADDR,PCR
					CMPX	#$8000

					BCS		LINEDDA_LINE_ROTATION_DEMO_ONESTEP_END
					BEQ		LINEDDA_LINE_ROTATION_DEMO_ONESTEP_END
					LDX		#0
					STX		LINEDDA_LINE_ROTATION_DEMO_VRAMADDR,PCR
					INC		LINEDDA_LINE_ROTATION_DEMO_OVER,PCR

LINEDDA_LINE_ROTATION_DEMO_ONESTEP_END
					PULS	A,B,X,Y,U,PC



LINEDDA_LINE_ROTATION_DEMO_CLEANUP
					RTS



LINEDDA_LINE_ROTATION_DEMO_MOVE
					CMPX	#0
					BEQ		LINEDDA_LINE_ROTATION_DEMO_MOVE_XMIN
					CMPX	#639
					BEQ		LINEDDA_LINE_ROTATION_DEMO_MOVE_XMAX
					CMPY	#0
					BEQ		LINEDDA_LINE_ROTATION_DEMO_MOVE_YMIN

LINEDDA_LINE_ROTATION_DEMO_MOVE_YMAX
					LEAX	20,X
					CMPX	#639
					BLE		LINEDDA_LINE_ROTATION_DEMO_MOVE_YMAX_NEXT
					TFR		X,D
					SUBD	#639
					COMA
					COMB
					ADDD	#1
					ADDD	#199
					TFR		D,Y
					LDX		#639
LINEDDA_LINE_ROTATION_DEMO_MOVE_YMAX_NEXT
					RTS

LINEDDA_LINE_ROTATION_DEMO_MOVE_XMIN
					LEAY	10,Y
					CMPY	#199
					BLE		LINEDDA_LINE_ROTATION_DEMO_MOVE_XMIN_NEXT
					TFR		Y,D
					SUBD	#199
					TFR		D,X
					LDY		#199
LINEDDA_LINE_ROTATION_DEMO_MOVE_XMIN_NEXT
					RTS

LINEDDA_LINE_ROTATION_DEMO_MOVE_XMAX
					LEAY	-10,Y
					CMPY	#0
					BGE		LINEDDA_LINE_ROTATION_DEMO_MOVE_XMAX_NEXT
					TFR		Y,D
					LDX		#639
					LEAX	D,X
					LDY		#0
LINEDDA_LINE_ROTATION_DEMO_MOVE_XMAX_NEXT
					RTS

LINEDDA_LINE_ROTATION_DEMO_MOVE_YMIN
					LEAX	-20,X
					CMPX	#0
					BGE		LINEDDA_LINE_ROTATION_DEMO_MOVE_YMIN_NEXT
					TFR		X,D
					COMA
					COMB
					ADDD	#1
					TFR		D,Y
					LDX		#0
LINEDDA_LINE_ROTATION_DEMO_MOVE_YMIN_NEXT
					RTS

LINEDDA_LINE_ROTATION_DEMO_X0		FDB	0
LINEDDA_LINE_ROTATION_DEMO_Y0		FDB	0
LINEDDA_LINE_ROTATION_DEMO_X1		FDB	0
LINEDDA_LINE_ROTATION_DEMO_Y1		FDB	0
LINEDDA_LINE_ROTATION_DEMO_VRAMADDR	FDB	0



